#include <linux/crypto.h>
#include <linux/err.h>
#include <linux/scatterlist.h>

static struct scatterlist sg_text;
static char result[128];
static struct crypto_hash *tfm;
static struct hash_desc desc;

static int __init mod_init( void )
{
	struct page *pg;
	char *buf;
	int i;

	pg = alloc_pages( GFP_USER, 0 );
	if (pg==NULL) {
		printk("alloc_pages failed\n");
		return -EIO;
	}
	buf = page_address( pg );
	memcpy( buf, "Linux-Magazin", 13 );

	sg_init_table( &sg_text, 1 );
	sg_set_page( &sg_text, pg, 13, 0 );

	tfm = crypto_alloc_hash("md5", 0, CRYPTO_ALG_ASYNC);
	if (IS_ERR(tfm)) {
		printk("crypto_alloc_hash failed\n");
		goto out_free_pages;
	}

	desc.tfm = tfm;
	desc.flags = 0;

	if (crypto_hash_digest(&desc, &sg_text, 13, result)) {
		printk("crypto_hash_digest failed\n");
	} else {
		printk("result hash_digest:\n");
		for (i=0; i<crypto_hash_digestsize(tfm); i++ ) {
			printk("%02x ", (unsigned char) result[i]);
		}
		printk("\n");
	}

	crypto_free_hash(tfm);
out_free_pages:
	free_pages( (unsigned long) page_address(pg), 0 );
	return -EIO;
}

static void __exit mod_exit( void )
{
	return;
}

module_init( mod_init );
module_exit( mod_exit );
MODULE_LICENSE("GPL");
